#include "drive.h"
#include "panic.h"
#include "fat.h"
#include "log.h"

uint8_t n_drives;
struct drive drives[256];

void init_drives() {
  n_drives = 0;
}

__attribute__ ((const))
static file_id_t unknown_get_file(const struct drive *d, const char *path) {
  return 0;
}

__attribute__ ((const))
static uint32_t unknown_get_free_sectors(const struct drive *d) {
  return 0;
}

__attribute__ ((const))
static uint32_t unknown_enumerate_dir(const struct drive *d, const char *path, struct directory_content_info *info, uint32_t max) {
  return 0;
}

__attribute__ ((const))
static uint32_t unknown_n_dir_entries(const struct drive *d, const char *path) {
  return 0;
}

static void unknown_no_call(const struct drive *d) {
  logf(LOG_ERROR, "file-level operation called on drive %u (%s), which is an unknown file system", d - drives + 1, d->fs_type);
}

static inline void determine_fs(struct drive *d) {
  if (try_fat_init_drive(d))
    return;

  d->fs_type = "Unknown";
  d->get_file = &unknown_get_file;
  d->free_file = &unknown_no_call;
  d->load_sector = &unknown_no_call;
  d->save_sector = &unknown_no_call;
  d->is_writable = &unknown_no_call;
  d->get_file_length = &unknown_no_call;
  d->set_file_length = &unknown_no_call;
  d->enumerate_dir = &unknown_enumerate_dir;
  d->n_dir_entries = &unknown_n_dir_entries;
  d->get_free_sectors = &unknown_get_free_sectors;
}

//drive should be ready before this.
//determine_fs and its children
//do not need to make ready or done
void commit_drive(struct drive data) {
  determine_fs(&data);
  drives[n_drives] = data;
  data.done(drives + n_drives);
  ++n_drives;
}